module.exports.getToken = async (client_id, client_secret, auth_url) => {
  // REQ AXIOS
  const axios = require("axios");

  const data = `grant_type=client_credentials&client_id=${client_id}&client_secret=${client_secret}`;

  const config = {
    method: "post",
    url: `${auth_url}`,
    data: data,
  };

  const response = await axios(config);

  const token = response.data.access_token;

  return token;
};

module.exports.getTables = async (caspio) => {
  const response = await caspio.get("tables");
  const tables = response.data.Result;
  return tables;
};

module.exports.getRecords = async (caspio, tableName, queries) => {
  const qs = require("qs");
  let parameters = "?";
  let response;

  if (queries.length > 0) {
    for (p = 0; p < queries.length; p++) {
      if (p === queries.length - 1) {
        parameters = parameters.concat(`${qs.stringify(queries[p])}`);
      } else {
        parameters = parameters.concat(`${qs.stringify(queries[p])}&`);
      }
    }
    response = await caspio.get(`tables/${tableName}/records${parameters}`);
    const records = response.data.Result;
    return records;
  } else {
    response = await caspio.get(`tables/${tableName}/records`);
    const records = response.data;
    return records;
  }
};
